Bug 1860729 - Review Request: wshowkeys - Displays keypresses on screen on supported Wayland compositors
Summary: Review Request: wshowkeys - Displays keypresses on screen on supported Waylan...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Qiyu Yan
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2020-07-27 01:51 UTC by Bob Hepple
Modified: 2020-08-07 01:19 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-08-07 01:08:42 UTC
Type: ---
yanqiyu01: fedora-review+


Attachments (Terms of Use)

Description Bob Hepple 2020-07-27 01:51:42 UTC
Spec URL: https://download.copr.fedorainfracloud.org/results/wef/wshowkeys/fedora-31-x86_64/01576270-wshowkeys/wshowkeys.spec

SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/wshowkeys/fedora-31-x86_64/01576270-wshowkeys/wshowkeys-0-1.20200727git6388a49.fc31.src.rpm

Description: Displays keypresses on screen on supported Wayland compositors (requires wlr_layer_shell_v1 support).

Usage

wshowkeys [-b|-f|-s #RRGGBB[AA]] [-F font] [-t timeout]
    [-a top|left|right|bottom] [-m margin] [-o output]

    -b #RRGGBB[AA]: set background color
    -f #RRGGBB[AA]: set foreground color
    -s #RRGGBB[AA]: set color for special keys
    -F font: set font (Pango format, e.g. 'monospace 24')
    -t timeout: set timeout before clearing old keystrokes
    -a top|left|right|bottom: anchor the keystrokes to an edge. May be specified twice.
    -m margin: set a margin (in pixels) from the nearest edge
    -o output: request wshowkeys is shown on the specified output

Fedora Account System Username: wef

Comment 2 Qiyu Yan 2020-07-29 03:09:00 UTC
Since /usr/bin/wshowkeys has setuid flag, things are getting diffficult (otherwise this will be a security risk)
What you should do (I think) is
 - Suggest: Check if the setuid is needed
 - Must: set %global _hardened_build 1
 - Suggest: deal with missing-call-to-setgroups-before-setuid, maybe you need to patch the code
And try to make this as safe as possible (maybe set permission to 4711).

Suggest part is not so important, but my personal advice...

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package uses hardened build flags if required to.
  Note: suid files: wshowkeys and not %global _hardened_build
  See: https://docs.fedoraproject.org/en-US/packaging-
  guidelines/#_compiler_flags


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "NTP License (legal disclaimer)". 12
     files have unknown license. Detailed output of licensecheck in
     /home/yan/review/copr-build-1582100/review-wshowkeys/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: wshowkeys-0-2.20200727git6388a49.fc33.x86_64.rpm
          wshowkeys-debuginfo-0-2.20200727git6388a49.fc33.x86_64.rpm
          wshowkeys-debugsource-0-2.20200727git6388a49.fc33.x86_64.rpm
          wshowkeys-0-2.20200727git6388a49.fc33.src.rpm
wshowkeys.x86_64: W: spelling-error %description -l en_US wlr -> war, SLR
# That is normal
wshowkeys.x86_64: W: spelling-error %description -l en_US eg -> eh, e, g
# also fine
wshowkeys.x86_64: W: spelling-error %description -l en_US monospace -> mono space, mono-space, aerospace
# I think this is normal
wshowkeys.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/wshowkeys
wshowkeys.x86_64: E: setuid-binary /usr/bin/wshowkeys root 4755
# if setuid is required, we can ignore this
wshowkeys.x86_64: E: non-standard-executable-perm /usr/bin/wshowkeys 4755
# also if setuid is required, we can ignore this
wshowkeys.x86_64: W: no-manual-page-for-binary wshowkeys
wshowkeys.src: W: spelling-error %description -l en_US wlr -> war, SLR
wshowkeys.src: W: spelling-error %description -l en_US eg -> eh, e, g
wshowkeys.src: W: spelling-error %description -l en_US monospace -> mono space, mono-space, aerospace
4 packages and 0 specfiles checked; 3 errors, 7 warnings.




Rpmlint (debuginfo)
-------------------
Checking: wshowkeys-debuginfo-0-2.20200727git6388a49.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
(none): E: no installed packages by name wshowkeys-debuginfo
(none): E: no installed packages by name wshowkeys
0 packages and 0 specfiles checked; 0 errors, 0 warnings.
(none): E: no installed packages by name wshowkeys-debugsource



Source checksums
----------------
https://git.sr.ht/~sircmpwn/wshowkeys/archive/6388a49e0f431d6d5fcbd152b8ae4fa8e87884ee.tar.gz#/wshowkeys-6388a49e0f431d6d5fcbd152b8ae4fa8e87884ee.tar.gz :
  CHECKSUM(SHA256) this package     : 8d4c0cee88c2147044bd2ef12948e5d823fc0f016c1e30ea6888553902aff446
  CHECKSUM(SHA256) upstream package : 8d4c0cee88c2147044bd2ef12948e5d823fc0f016c1e30ea6888553902aff446


Requires
--------
wshowkeys (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcairo.so.2()(64bit)
    libgobject-2.0.so.0()(64bit)
    libinput.so.10()(64bit)
    libinput.so.10(LIBINPUT_0.12.0)(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    librt.so.1()(64bit)
    libudev.so.1()(64bit)
    libudev.so.1(LIBUDEV_183)(64bit)
    libwayland-client.so.0()(64bit)
    libxkbcommon.so.0()(64bit)
    libxkbcommon.so.0(V_0.5.0)(64bit)
    rtld(GNU_HASH)

wshowkeys-debuginfo (rpmlib, GLIBC filtered):

wshowkeys-debugsource (rpmlib, GLIBC filtered):



Provides
--------
wshowkeys:
    wshowkeys
    wshowkeys(x86-64)

wshowkeys-debuginfo:
    debuginfo(build-id)
    wshowkeys-debuginfo
    wshowkeys-debuginfo(x86-64)

wshowkeys-debugsource:
    wshowkeys-debugsource
    wshowkeys-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review --copr-build 01582100
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Ocaml, PHP, SugarActivity, Perl, Haskell, R, fonts, Python, Java
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 3 Bob Hepple 2020-07-29 05:44:04 UTC
Thanks for the review!

From the upstream homepage: "wshowkeys must be configured as setuid during installation. It requires root permissions to read input events. These permissions are dropped after startup." I confirmed this by trying to run without setuid.

I have added '_hardened_build' as required.

It appears to work fine with mode 4711 so I've adopted that.

As for missing-call-to-setgroups-before-setuid I've not been able to silence it.

I thought it might be related to https://wiki.sei.cmu.edu/confluence/display/c/POS36-C.+Observe+correct+revocation+order+while+relinquishing+privileges - but upstream seems to have done it the right way - but that's related to setgid() rather than setgroups(). I tried addin a call to setgid(0) before setuid(0) but that does not silence rpmlint.

I tried including a call to setgroups but I can't get the compiler to accept it:

#include <grp.h>
...
	if (setgroups(0, NULL) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}

and the compiler error:

../devmgr.c: In function ‘devmgr_start’:
../devmgr.c:161:6: error: implicit declaration of function ‘setgroups’; did you mean ‘getgroups’? [-Werror=implicit-function-declaration]
  161 |  if (setgroups(0, NULL) != -1) {
      |      ^~~~~~~~~
      |      getgroups

... not sure how to progress that.

Spec URL: https://download.copr.fedorainfracloud.org/results/wef/wshowkeys/fedora-31-x86_64/01585065-wshowkeys/wshowkeys.spec
SRPM URL: https://download.copr.fedorainfracloud.org/results/wef/wshowkeys/fedora-31-x86_64/01585065-wshowkeys/wshowkeys-0-3.20200727git6388a49.fc31.src.rpm

Comment 4 Qiyu Yan 2020-07-29 06:20:46 UTC
(In reply to Bob Hepple from comment #3)
> Thanks for the review!
> 
> From the upstream homepage: "wshowkeys must be configured as setuid during
> installation. It requires root permissions to read input events. These
> permissions are dropped after startup." I confirmed this by trying to run
> without setuid.
> 
> I have added '_hardened_build' as required.
> 
> It appears to work fine with mode 4711 so I've adopted that.
> 
> As for missing-call-to-setgroups-before-setuid I've not been able to silence
> it.
Okay, I just found some packages that was already in Fedora can trigger this error. 
Maybe we can continue anyway, but I think we should have another one try.
> 
> I thought it might be related to
> https://wiki.sei.cmu.edu/confluence/display/c/POS36-C.
> +Observe+correct+revocation+order+while+relinquishing+privileges - but
> upstream seems to have done it the right way - but that's related to
> setgid() rather than setgroups(). I tried addin a call to setgid(0) before
> setuid(0) but that does not silence rpmlint.
> 
> I tried including a call to setgroups but I can't get the compiler to accept
> it:
> 
> #include <grp.h>
> ...
> 	if (setgroups(0, NULL) != -1) {
> 		fprintf(stderr, "devmgr: failed to drop root\n");
> 		return 1;
> 	}
> 
> and the compiler error:
> 
> ../devmgr.c: In function ‘devmgr_start’:
> ../devmgr.c:161:6: error: implicit declaration of function ‘setgroups’; did
> you mean ‘getgroups’? [-Werror=implicit-function-declaration]
>   161 |  if (setgroups(0, NULL) != -1) {
>       |      ^~~~~~~~~
>       |      getgroups
> 
> ... not sure how to progress that.
Can you try to add 
#define _GNU_SOURCE
before including the headers?

Comment 5 Bob Hepple 2020-07-29 06:31:02 UTC
Cool - that stopped the compiler error.

This is now the code:


	if (setgid(getgid()) != 0) {
		fprintf(stderr, "devmgr: setgid: %s\n", strerror(errno));
		return 1;
	}
	if (setuid(getuid()) != 0) {
		fprintf(stderr, "devmgr: setuid: %s\n", strerror(errno));
		return 1;
	}
	if (setgroups(0, NULL) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}
	if (setuid(0) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}

The program works as before but rpmlint still complains:

$ rpmlint /home/bhepple/rpmbuild/RPMS/x86_64/wshowkeys-0-3.20200727git6388a49.fc31.x86_64.rpm
wshowkeys.x86_64: W: spelling-error %description -l en_US wlr -> war, SLR
wshowkeys.x86_64: W: spelling-error %description -l en_US eg -> eh, e, g
wshowkeys.x86_64: W: spelling-error %description -l en_US monospace -> mono space, mono-space, aerospace
wshowkeys.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/wshowkeys
wshowkeys.x86_64: E: setuid-binary /usr/bin/wshowkeys root 4711
wshowkeys.x86_64: E: non-standard-executable-perm /usr/bin/wshowkeys 4711
wshowkeys.x86_64: E: non-standard-executable-perm /usr/bin/wshowkeys 4711
wshowkeys.x86_64: W: no-manual-page-for-binary wshowkeys
1 packages and 0 specfiles checked; 4 errors, 4 warnings.

Since I'm fumbling in the dark here, I also tried this:


	if (setgroups(0, NULL) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}
	if (setgid(getgid()) != 0) {
		fprintf(stderr, "devmgr: setgid: %s\n", strerror(errno));
		return 1;
	}
	if (setuid(getuid()) != 0) {
		fprintf(stderr, "devmgr: setuid: %s\n", strerror(errno));
		return 1;
	}
	if (setuid(0) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}

... but no joy

Comment 6 Qiyu Yan 2020-07-29 06:58:34 UTC
Okay, I checked the code, and think this can be a mis-report, So, I am approving this.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: If your application is a C or C++ application you must list a
     BuildRequires against gcc, gcc-c++ or clang.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
     Note: Using prebuilt packages
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "NTP License (legal disclaimer)". 12
     files have unknown license. Detailed output of licensecheck in
     /home/yan/review/copr-build-1582100/review-wshowkeys/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: Package contains systemd file(s) if in need.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: Reviewer should test that the package builds in mock.
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: wshowkeys-0-3.20200727git6388a49.fc33.x86_64.rpm
          wshowkeys-debuginfo-0-3.20200727git6388a49.fc33.x86_64.rpm
          wshowkeys-debugsource-0-3.20200727git6388a49.fc33.x86_64.rpm
          wshowkeys-0-3.20200727git6388a49.fc33.src.rpm
wshowkeys.x86_64: W: spelling-error %description -l en_US wlr -> war, SLR
wshowkeys.x86_64: W: spelling-error %description -l en_US eg -> eh, e, g
wshowkeys.x86_64: W: spelling-error %description -l en_US monospace -> mono space, mono-space, aerospace
wshowkeys.x86_64: E: missing-call-to-setgroups-before-setuid /usr/bin/wshowkeys
# Manual check, 
	if (setgid(getgid()) != 0) {
		fprintf(stderr, "devmgr: setgid: %s\n", strerror(errno));
		return 1;
	}
	if (setuid(getuid()) != 0) {
		fprintf(stderr, "devmgr: setuid: %s\n", strerror(errno));
		return 1;
	}
If correct behavior, maybe a mis-report.
See: 
https://wiki.sei.cmu.edu/confluence/display/c/POS36-C.+Observe+correct+revocation+order+while+relinquishing+privileges

wshowkeys.x86_64: E: setuid-binary /usr/bin/wshowkeys root 4711
wshowkeys.x86_64: E: non-standard-executable-perm /usr/bin/wshowkeys 4711
wshowkeys.x86_64: E: non-standard-executable-perm /usr/bin/wshowkeys 4711
# the three above are not problem 
wshowkeys.x86_64: W: no-manual-page-for-binary wshowkeys
wshowkeys.src: W: spelling-error %description -l en_US wlr -> war, SLR
wshowkeys.src: W: spelling-error %description -l en_US eg -> eh, e, g
wshowkeys.src: W: spelling-error %description -l en_US monospace -> mono space, mono-space, aerospace
wshowkeys.src: W: invalid-url URL: https://git.sr.ht/~sircmpwn/wshowkeys The read operation timed out
4 packages and 0 specfiles checked; 4 errors, 8 warnings.




Rpmlint (debuginfo)
-------------------
Checking: wshowkeys-debuginfo-0-3.20200727git6388a49.fc33.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
(none): E: no installed packages by name wshowkeys-debuginfo
(none): E: no installed packages by name wshowkeys
0 packages and 0 specfiles checked; 0 errors, 0 warnings.
(none): E: no installed packages by name wshowkeys-debugsource



Source checksums
----------------
https://git.sr.ht/~sircmpwn/wshowkeys/archive/6388a49e0f431d6d5fcbd152b8ae4fa8e87884ee.tar.gz#/wshowkeys-6388a49e0f431d6d5fcbd152b8ae4fa8e87884ee.tar.gz :
  CHECKSUM(SHA256) this package     : 8d4c0cee88c2147044bd2ef12948e5d823fc0f016c1e30ea6888553902aff446
  CHECKSUM(SHA256) upstream package : 8d4c0cee88c2147044bd2ef12948e5d823fc0f016c1e30ea6888553902aff446


Requires
--------
wshowkeys (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libcairo.so.2()(64bit)
    libgobject-2.0.so.0()(64bit)
    libinput.so.10()(64bit)
    libinput.so.10(LIBINPUT_0.12.0)(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    librt.so.1()(64bit)
    libudev.so.1()(64bit)
    libudev.so.1(LIBUDEV_183)(64bit)
    libwayland-client.so.0()(64bit)
    libxkbcommon.so.0()(64bit)
    libxkbcommon.so.0(V_0.5.0)(64bit)
    rtld(GNU_HASH)

wshowkeys-debuginfo (rpmlib, GLIBC filtered):

wshowkeys-debugsource (rpmlib, GLIBC filtered):



Provides
--------
wshowkeys:
    wshowkeys
    wshowkeys(x86-64)

wshowkeys-debuginfo:
    debuginfo(build-id)
    wshowkeys-debuginfo
    wshowkeys-debuginfo(x86-64)

wshowkeys-debugsource:
    wshowkeys-debugsource
    wshowkeys-debugsource(x86-64)



Generated by fedora-review 0.7.5 (5fa5b7e) last change: 2020-02-16
Command line :/usr/bin/fedora-review --copr-build 01585065
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, C/C++, Shell-api
Disabled plugins: R, Python, Haskell, SugarActivity, Perl, PHP, Ocaml, Java, fonts
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 7 Bob Hepple 2020-07-29 07:37:16 UTC
I'm an idiot! I forgot to re-apply the patch to the spec file in my rush to get out the door.

This version silences rpmlint:


	if (setgid(getgid()) != 0) {
		fprintf(stderr, "devmgr: setgid: %s\n", strerror(errno));
		return 1;
	}
	if (setuid(getuid()) != 0) {
		fprintf(stderr, "devmgr: setuid: %s\n", strerror(errno));
		return 1;
	}
	if (setgroups(0, NULL) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}
	if (setuid(0) != -1) {
		fprintf(stderr, "devmgr: failed to drop root\n");
		return 1;
	}

Shall I go ahead with release 3.20200727git6388a49 without the patch or include a patch in release 4... ???

Thanks again and sorry for the confusion.

Comment 8 Qiyu Yan 2020-07-29 07:46:07 UTC
No need to include the patch, since rpmlint is complaining about this call:
setuid(0) != -1
this is just a check and actually won't lead to any security problems.

So no need to include the patch, present version is perfect.

Comment 9 Bob Hepple 2020-07-29 07:49:15 UTC
All good then - I'll go ahead and request the repo.

Thanks again!

Comment 10 Gwyn Ciesla 2020-07-29 13:13:41 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/wshowkeys

Comment 11 Fedora Update System 2020-07-29 22:49:57 UTC
FEDORA-2020-4a56c76e02 has been submitted as an update to Fedora 31. https://bodhi.fedoraproject.org/updates/FEDORA-2020-4a56c76e02

Comment 12 Fedora Update System 2020-07-29 23:01:36 UTC
FEDORA-2020-ec0c72eb82 has been submitted as an update to Fedora 32. https://bodhi.fedoraproject.org/updates/FEDORA-2020-ec0c72eb82

Comment 13 Fedora Update System 2020-07-30 19:41:53 UTC
FEDORA-2020-4a56c76e02 has been pushed to the Fedora 31 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-4a56c76e02 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-4a56c76e02

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 14 Fedora Update System 2020-07-30 19:55:10 UTC
FEDORA-2020-ec0c72eb82 has been pushed to the Fedora 32 testing repository.
In short time you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --advisory=FEDORA-2020-ec0c72eb82 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2020-ec0c72eb82

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 15 Fedora Update System 2020-08-07 01:08:42 UTC
FEDORA-2020-4a56c76e02 has been pushed to the Fedora 31 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 16 Fedora Update System 2020-08-07 01:19:07 UTC
FEDORA-2020-ec0c72eb82 has been pushed to the Fedora 32 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.